module.exports = addSchemaDoc;
function addSchemaDoc(rootApp,systemApp) {

    function routerConfig(router){
        let title = matchBinder(rootApp, router.path).config.title;
        let path = router.path;
        return {title,path}
    }

    systemApp.get('/api/',function *(req,resp){
        try{
            resp.writeHead(404, {'Content-Type': 'text/html;charset=utf-8'})
            this.routes = rootApp._routes[1].map(routerConfig);
            return "/404.xhtml"
        }catch(e){
            console.log(e);
            return 404;
        }
    })

    systemApp.get('/api/*', function *(req,resp){
        //console.log("!!!!!!!",req.params[0])
        try{
            let path = decodeURIComponent(req.params[0]);
            //console.log(path)
            let binder = matchBinder(rootApp, path)
            let model = binder && genApiDoc(rootApp, binder, path);
            if(model){
                for(var n in model){
                    this[n] = model[n];
                }
                return '/api-doc.xhtml';
            }else{
                //console.log('model:',binder,path)
                resp.writeHead(404, {'Content-Type': 'text/html;charset=utf-8'})
                this.api = path;
                this.routes = rootApp._routes[1].map(routerConfig);
                return "/404.xhtml"
            }
        }catch(e){
            console.log(e);
            return 404;
        }
    })
    return rootApp;
}
function matchBinder(app, path) {
    let list = app._routes[1];
    let len = list.length;
    let startIndex = 0;
    while (startIndex < len) {
        let binder = list[startIndex++];
        if (path == binder.path) {
            return binder;
        }
    }
}
function genApiDoc(app,binder,path){
    let action = binder.action;
    let config = binder.config;
    let method = {};
    let model = {
        path:path,
        title:config.title,
        method:method,
        util:{
            genid(path,id){
                return (path+'__'+id).replace(/[^\w]/g,'_')
            },
            genTips(schema){

                schema = schema.anyOf && schema.anyOf[0]||schema;

                var buf = []
                for(var n in schema){
                    if(!/^(?:\$ref|type|description|items|anyOf|optional)\b/.test(n))buf.push(n+':'+JSON.stringify(schema[n]))
                }
                return buf.join('\n')
            }
        }
    };

    for(let n in action){
        method[n] = {impl:action[n]+''}
    }
    for(let n in config){
        if(n!='path' && n!='title'){
            let conf = method[n] = method[n] || {};
            let validator = config[n].validator;
            conf.config = {
                validator:validator && {
                    request:validator.request && validator.request.schema,
                    response:validator.response && validator.response.schema,
                    refs:validator.ref
                }
            };
        }
    }
    return model;
}

