
function dropFile(e){
    e.stopPropagation();
    e.preventDefault();

    handleFiles(e.dataTransfer.files);
    return false;
}
function handleFiles(files){
    var map = {};
    var completed = 0;
    function load(e){
        var reader = e.target;
        var item = map[reader.name] = {};
        item.data = reader.result;
        item.type = reader.type;
        if(++completed == files.length){
            //console.dir(map)
            upload(map)
        }
    }
    console.log(files.length)
    for (var i = 0; i < files.length; i++) {
        var file = files[i];
        //console.log(file);
        var reader = new FileReader();
        reader.name = file.name;
        reader.type = file.type;
        reader.onload = load;
        reader.readAsBinaryString(file);
    }
}

function upload(map){
    var xhr = new XMLHttpRequest();
    var boundary = Math.random().toString(32).substr(2)
    xhr.open('post', '/$/upload/apk/', true);
    xhr.setRequestHeader("Content-Type", "multipart/form-data; boundary="+boundary); // simulate a file MIME POST request.


    var body = [];
    body.push("--", boundary, "\r\n")
    body.push("Content-Disposition: form-data; name=\"urlBase\"\r\n");
    body.push(location.href.replace(/(\w+)\/.*$/,'$1'), "\r\n");
    for(var name in map) {
        var content = map[name]
        body.push("--", boundary, "\r\n")
        body.push("Content-Disposition: form-data; name=\"", name, "\"; filename=\"", name, "\"\r\n");
        body.push("Content-Type: ", content.type, "\r\n\r\n");
        body.push(content.data, "\r\n");
        //body.push("--", boundary, "--\r\n");
    }
    body.push("--", boundary, "--\r\n");
    body = body.join('');
    //xhr.setRequestHeader("Content-Length", body.length);
    xhr.onreadystatechange = function(){
        //console.log(xhr.readyState)
        if(xhr.readyState == 4){
            //console.log(map)
            var json = JSON.parse(xhr.responseText);
            if(json.path){
                confirm('apk 发布成功！，请扫码更新');
                qrResult.src = json.dataURL;
            }
        }
    }
    xhr.send(body);
}

function doTest(thiz, method, path) {
    if (/get/i.test(method)) {
        var url = path.replace(/\:(\w+)/, function (a) {
            return prompt(a, '');
        })
        thiz.href = (url);
    } else {
        var map = {}
        var url = path.replace(/\:(\w+)/, function (a, key) {
            return map[key] = prompt(a, '');
        })
        var json = prompt('input ' + method + ' data', JSON.stringify(map));
        if (json.match(/^\s*\{/)) {
            try {
                map = JSON.parse(json);
            } catch (e) {
                console.log(e);
                alert('invalid json:' + e + json)
                return false;
            }
            var isJSON = true;
        } else {//url encoded
            map = {};
            json.replace(/([^=]+)(?:=([^\u0026]*))/g, function (a, key, value) {
                key = decodeURIComponent(key);
                value = decodeURIComponent(value);
                if (key in map) {
                    map[key] = [].concat(map[key], value)
                } else {
                    map[key] = value;
                }
            })
        }
        var url = path.replace(/\:(\w+)/, function (a, key) {
            var value = map[key];
            delete map[key];
            return value;
        })

        function encodeParam(map) {
            var buf = [];
            for (var n in map) {
                var v = map[n];
                n = encodeURIComponent(n);
                if (v instanceof Array) {
                    buf.push(v.map(function (a) {
                        return n + '[]=' + encodeURIComponent(a)
                    }))
                }
                buf.push(n + '=' + encodeURIComponent(v))
            }
            return buf.join('\u0026');
        }

        var postData = isJSON ? JSON.stringify(map) : encodeParam(map);
        var xhr = new XMLHttpRequest();
        xhr.onreadystatechange = function () {
            if (xhr.readyState == 4) {
                alert('test result:\n' + xhr.responseText);
            }
        }
        xhr.open(method.toUpperCase(), url, true)
        xhr.setRequestHeader("Content-Type",
            isJSON ? "application/json" : "application/x-www-form-urlencoded")
        xhr.send(postData);
        return false;
    }
}
